package ap;

import scala.testing.SUnit
import SUnit._

object AllTests extends TestSuite with Application {

  addTest(new ap.basetypes.TestIdealInt ("testDiv"))
  addTest(new ap.basetypes.TestIdealInt ("testReduceAbs"))
  addTest(new ap.basetypes.TestIdealInt ("testGcdAndCofactors1"))
  addTest(new ap.basetypes.TestIdealInt ("testGcdAndCofactorsSeq"))
  addTest(new ap.basetypes.TestIdealInt ("testGcdSeq"))
  addTest(new ap.basetypes.TestLeftistHeap ("testInsertElements"))
  addTest(new ap.basetypes.TestLeftistHeap ("testInsertIterator"))
  addTest(new ap.basetypes.TestLeftistHeap ("testInsertHeap"))
  addTest(new ap.basetypes.TestLeftistHeap ("testRemoveAll"))
  addTest(new ap.basetypes.TestLeftistHeap ("testLargeHeap"))
  addTest(new ap.basetypes.TestLeftistHeap ("testHeapCollector"))
  addTest(new ap.basetypes.TestLeftistHeap ("testFlatMap"))
  addTest(new ap.terfor.TestTermOrder ("testSimpleExtension"))
  addTest(new ap.terfor.TestTermOrder ("testConditionalExtension"))
  addTest(new ap.terfor.TestTermOrder ("testLinearCombinationComparison"))
  addTest(new ap.terfor.TestPropConnectives ("testArithConj1"))
  addTest(new ap.terfor.TestPropConnectives ("testArithConj2"))
  addTest(new ap.terfor.TestPropConnectives ("testArithConj3"))
  addTest(new ap.terfor.TestPropConnectives ("testConj1"))
  addTest(new ap.terfor.TestPropConnectives ("testConj2"))
  addTest(new ap.terfor.TestPropConnectives ("testReduceWithConjunction1"))
  addTest(new ap.terfor.TestPropConnectives ("testReduceWithConjunction2"))
  addTest(new ap.terfor.linearcombination.TestLinearCombination ("testLC1"))
  addTest(new ap.terfor.linearcombination.TestLinearCombination ("testLCFlatten"))
  addTest(new ap.terfor.linearcombination.TestLinearCombination ("testLCAddition1"))
  addTest(new ap.terfor.linearcombination.TestLinearCombination ("testLCAddition2"))
  addTest(new ap.terfor.linearcombination.TestLinearCombination ("testLCAddition3"))
  addTest(new ap.terfor.equations.TestEquationSet ("testConj1"))
  addTest(new ap.terfor.equations.TestEquationSet ("testNegConj1"))
  addTest(new ap.terfor.equations.TestEquationSet ("testReduceWithEqs1"))
  addTest(new ap.terfor.equations.TestEquationSet ("testReduceWithEqs2"))
  addTest(new ap.terfor.equations.TestEquationSet ("testReduceWithEqs3"))
  addTest(new ap.terfor.equations.TestEquationSet ("testReduceDisj"))
  addTest(new ap.terfor.inequalities.TestInequalities ("testConj1"))
  addTest(new ap.terfor.inequalities.TestInequalities ("testConj2"))
  addTest(new ap.terfor.inequalities.TestInequalities ("testReduceWithInEqs1"))
  addTest(new ap.terfor.inequalities.TestInequalities ("testReduceWithInEqs2"))
  addTest(new ap.terfor.substitutions.TestSubst ("testPseudoSubst"))  
  addTest(new ap.proof.TestEquationSystems ("testEqs1"))
  addTest(new ap.proof.TestEquationSystems ("testEqs2"))
  addTest(new ap.proof.TestEquationSystems ("testQuantifiedEqs1"))
  addTest(new ap.proof.TestEquationSystems ("testDivisibility1"))
  addTest(new ap.proof.TestRandomProving ("testEqFormulas1"))
  addTest(new ap.proof.TestRandomProving ("testEqFormulas2"))
  addTest(new ap.proof.TestRandomProving ("testFormulas1"))
  addTest(new ap.proof.TestRandomProving ("testFormulas2"))
/*  addTest(new ap.TestProver ("testFilesTrue"))
  addTest(new ap.TestProver ("testFilesFalse"))
  addTest(new ap.TestProver ("testFilesCountermodel")) */

  val timeBefore = System.currentTimeMillis
  
  val r = new TestResult()
  run(r)
  
  val timeAfter = System.currentTimeMillis
    
  println
  println("Time needed: " + (timeAfter - timeBefore) + "ms")
  println
  
  for(val tf <- r.failures()) { 
    Console.println( tf.toString()) 
    Console.println( tf.trace )
  }
  
}
