package ap.basetypes;

object HeapCollector {
  
  class None[T] extends HeapCollector[T, None[T]] {
    def +(element : T, otherData : None[T]) : None[T] = this    
  }
  
  def NONE[T] = new None[T]
  
}

/**
 * A general interface for collecting informations about elements stored in a
 * heap (in particular, in a <code>LeftistHeap</code>). This class can be seen
 * as a monomoid morphism, mapping a heap (seen as a multiset or monoid) to
 * something else.
 */
trait HeapCollector[-T, HC] {

  def +(element : T, otherData : HC) : HC
  
}
