package ap.terfor;

import ap.terfor.preds.Predicate

/**
 * Extension of <code>Sorted</code> where also the actual <code>TermOrder</code>
 * can be queried
 */
trait SortedWithOrder[+T] extends Sorted[T] {

  val order : TermOrder
  
  def constants : Set[ConstantTerm]

  def predicates : Set[Predicate]

  def isSortedBy(otherOrder : TermOrder) : Boolean =
    order.isSubOrderOf(otherOrder, constants, predicates)
  
}
